package com.unipi.talepis.protal2022_5;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.Observer;
import androidx.room.Room;
import androidx.work.OneTimeWorkRequest;
import androidx.work.WorkManager;
import androidx.work.WorkRequest;

import android.os.Bundle;
import android.view.View;

public class MainActivity extends AppCompatActivity {
    AppDatabase db;
    UserDao userDao;
    MutableLiveData<User> userMutableLiveData;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        db = Room.databaseBuilder(getApplicationContext(),
                AppDatabase.class,"protal2022_5").allowMainThreadQueries().build();
        userDao = db.userDao();
        userMutableLiveData = new MutableLiveData<>();
        Observer<User> userObserver = new Observer<User>() {
            @Override
            public void onChanged(User user) {
                showMessage("User changed",user.toString());
            }
        };
        userMutableLiveData.observe(this,userObserver);
    }
    private void showMessage(String title, String message){
        new AlertDialog.Builder(this)
                .setTitle(title)
                .setMessage(message)
                .setCancelable(true)
                .show();
    }
    public void insert(View view){
        User user1 = new User(3,"Christos","Com");
        userDao.insertAll(user1);
        userMutableLiveData.postValue(user1);
    }
    public void select(View view){
        showMessage("All users",userDao.getAll().toString());
    }
    public void worker(View view){
        WorkRequest request = new OneTimeWorkRequest.Builder(MyWorker.class).build();
        WorkManager.getInstance(this).enqueue(request);
    }
}